searchNodes=[{"doc":"ExUnit assertions.","ref":"Moar.Assertions.html","title":"Moar.Assertions","type":"module"},{"doc":"Asserts that the left and right values are equal. Returns the left value unless the assertion fails, or unless the :returning option is used. Uses assert left == right under the hood. Style note: the authors prefer to use assert in most cases, using assert_eq only when the extra options are helpful or when they want to make assertions in a pipeline. Options: ignore_order: boolean - if the left and right values are lists, ignores the order when checking equality. returning: value - returns value if the assertion passes, rather than returning the left value. within: delta - asserts that the left and right values are within delta of each other. within: {delta, time_unit} - like within: delta but performs time comparisons in the specified time_unit . See Moar.Duration for more about time units. If left and right are strings, they are parsed as ISO8601 dates. Examples iex&gt; import Moar.Assertions iex&gt; %{ a : 1 } |&gt; Map . put ( :b , 2 ) |&gt; assert_eq ( %{ a : 1 , b : 2 } ) %{ a : 1 , b : 2 } iex&gt; map = %{ a : 1 , b : 2 } iex&gt; map |&gt; Map . get ( :a ) |&gt; assert_eq ( 1 , returning : map ) %{ a : 1 , b : 2 } iex&gt; assert_eq ( 4 / 28 , 0.14 , within : 0.01 ) 0.14285714285714285 iex&gt; inserted_at = ~U[2022-01-02 03:00:00Z] iex&gt; updated_at = ~U[2022-01-02 03:04:00Z] iex&gt; assert_eq ( inserted_at , updated_at , within : { 10 , :minute } ) ~U[2022-01-02 03:00:00Z] iex&gt; inserted_at = &quot;2022-01-02T03:00:00Z&quot; iex&gt; updated_at = &quot;2022-01-02T03:04:00Z&quot; iex&gt; assert_eq ( inserted_at , updated_at , within : { 10 , :minute } ) &quot;2022-01-02T03:00:00Z&quot;","ref":"Moar.Assertions.html#assert_eq/3","title":"Moar.Assertions.assert_eq/3","type":"function"},{"doc":"Asserts that a pre-condition and a post-condition are true after performing an action. Examples { :ok , agent } = Agent . start ( fn -&gt; 0 end ) assert_that ( Agent . update ( agent , fn s -&gt; s + 1 end ) , changes : Agent . get ( agent , fn s -&gt; s end ) , from : 0 , to : 1 )","ref":"Moar.Assertions.html#assert_that/2","title":"Moar.Assertions.assert_that/2","type":"macro"},{"doc":"","ref":"Moar.Assertions.html#t:assert_eq_opts/0","title":"Moar.Assertions.assert_eq_opts/0","type":"type"},{"doc":"Atom-related functions.","ref":"Moar.Atom.html","title":"Moar.Atom","type":"module"},{"doc":"Converts a string to an atom (via String.to_atom/1 ), and returns atoms unchanged. Useful when you aren't sure ahead of time whether you have a string or an atom.","ref":"Moar.Atom.html#from_string/1","title":"Moar.Atom.from_string/1","type":"function"},{"doc":"Converts an atom to a string (via Atom.to_string/1 ), and returns strings unchanged. Useful when you aren't sure ahead of time whether you have a string or an atom.","ref":"Moar.Atom.html#to_string/1","title":"Moar.Atom.to_string/1","type":"function"},{"doc":"DateTime-related functions.","ref":"Moar.DateTime.html","title":"Moar.DateTime","type":"module"},{"doc":"Like DateTime.from_iso8601/1 but raises if the string cannot be parsed.","ref":"Moar.DateTime.html#from_iso8601!/1","title":"Moar.DateTime.from_iso8601!/1","type":"function"},{"doc":"Like DateTime.to_iso8601/1 but rounds to the nearest second first.","ref":"Moar.DateTime.html#to_iso8601_rounded/1","title":"Moar.DateTime.to_iso8601_rounded/1","type":"function"},{"doc":"A protocol that defines diff/2 for finding the difference between two terms. Includes implementations for DateTime , NaiveDateTime , and BitString .","ref":"Moar.Difference.html","title":"Moar.Difference","type":"protocol"},{"doc":"Returns the difference between a and b . The fallback implementation uses Kernel.-/2 to subtract b from a .","ref":"Moar.Difference.html#diff/2","title":"Moar.Difference.diff/2","type":"function"},{"doc":"","ref":"Moar.Difference.html#t:t/0","title":"Moar.Difference.t/0","type":"type"},{"doc":"A duration is a {time, unit} tuple. The time is a number and the unit is one of: :nanosecond , :microsecond , :millisecond , :second , :minute , :hour , :day .","ref":"Moar.Duration.html","title":"Moar.Duration","type":"module"},{"doc":"Converts a {duration, time_unit} tuple into a numeric duration, rounding down to the nearest whole number. Uses System.convert_time_unit/3 under the hood; see its documentation for more details. Examples iex&gt; Moar.Duration . convert ( { 121 , :second } , :minute ) 2","ref":"Moar.Duration.html#convert/2","title":"Moar.Duration.convert/2","type":"function"},{"doc":"Converts a {duration, time_unit} tuple into a string. Examples iex&gt; Moar.Duration . to_string ( { 1 , :second } ) &quot;1 second&quot; iex&gt; Moar.Duration . to_string ( { 25 , :millisecond } ) &quot;25 milliseconds&quot;","ref":"Moar.Duration.html#to_string/1","title":"Moar.Duration.to_string/1","type":"function"},{"doc":"","ref":"Moar.Duration.html#t:duration/0","title":"Moar.Duration.duration/0","type":"type"},{"doc":"","ref":"Moar.Duration.html#t:time_unit/0","title":"Moar.Duration.time_unit/0","type":"type"},{"doc":"Enum-related functions.","ref":"Moar.Enum.html","title":"Moar.Enum","type":"module"},{"doc":"Like Enum.at/2 but raises if index is out of bounds.","ref":"Moar.Enum.html#at!/2","title":"Moar.Enum.at!/2","type":"function"},{"doc":"Removes nil elements from enum .","ref":"Moar.Enum.html#compact/1","title":"Moar.Enum.compact/1","type":"function"},{"doc":"Returns the first item of enum , or raises if it is empty.","ref":"Moar.Enum.html#first!/1","title":"Moar.Enum.first!/1","type":"function"},{"doc":"Sorts enum case-insensitively. Uses Enum.sort_by/3 under the hood.","ref":"Moar.Enum.html#isort/1","title":"Moar.Enum.isort/1","type":"function"},{"doc":"Sorts enum case-insensitively by mapper function. Uses Enum.sort_by/3 under the hood.","ref":"Moar.Enum.html#isort_by/2","title":"Moar.Enum.isort_by/2","type":"function"},{"doc":"Returns :tid fields from enumerable .","ref":"Moar.Enum.html#tids/1","title":"Moar.Enum.tids/1","type":"function"},{"doc":"File-related functions.","ref":"Moar.File.html","title":"Moar.File","type":"module"},{"doc":"Returns a path to a new temp file in a new temp directory.","ref":"Moar.File.html#new_tempfile_path/1","title":"Moar.File.new_tempfile_path/1","type":"function"},{"doc":"Writes contents to a new temp file with extension file_extension , and returns the path to the file.","ref":"Moar.File.html#write_tempfile/2","title":"Moar.File.write_tempfile/2","type":"function"},{"doc":"Map-related functions.","ref":"Moar.Map.html","title":"Moar.Map","type":"module"},{"doc":"Converts keys in map to atoms. iex&gt; Moar.Map . atomize_keys ( %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; 2 } ) %{ a : 1 , b : 2 }","ref":"Moar.Map.html#atomize_keys/1","title":"Moar.Map.atomize_keys/1","type":"function"},{"doc":"Converts keys to atoms, traversing through descendant lists and maps. iex&gt; Moar.Map . deep_atomize_keys ( %{ &quot;a&quot; =&gt; %{ &quot;aa&quot; =&gt; 1 } , &quot;b&quot; =&gt; [ %{ &quot;bb&quot; =&gt; 2 } , %{ &quot;bbb&quot; =&gt; 3 } ] } ) %{ a : %{ aa : 1 } , b : [ %{ bb : 2 } , %{ bbb : 3 } ] }","ref":"Moar.Map.html#deep_atomize_keys/1","title":"Moar.Map.deep_atomize_keys/1","type":"function"},{"doc":"Merges two enumerables into a single map. iex&gt; Moar.Map . merge ( %{ a : 1 } , [ b : 2 ] ) %{ a : 1 , b : 2 }","ref":"Moar.Map.html#merge/2","title":"Moar.Map.merge/2","type":"function"},{"doc":"Returns a copy of map with old_key_name changed to new_key_name . old_key_name and new_key_name are passed in as a {old_key_name, new_key_name} tuple. iex&gt; %{ &quot;color&quot; =&gt; &quot;red&quot; , &quot;size&quot; =&gt; &quot;medium&quot; } |&gt; Moar.Map . rename_key ( { &quot;color&quot; , &quot;colour&quot; } ) %{ &quot;colour&quot; =&gt; &quot;red&quot; , &quot;size&quot; =&gt; &quot;medium&quot; }","ref":"Moar.Map.html#rename_key/2","title":"Moar.Map.rename_key/2","type":"function"},{"doc":"Returns a copy of map with old_key_name changed to new_key_name . iex&gt; %{ &quot;color&quot; =&gt; &quot;red&quot; , &quot;size&quot; =&gt; &quot;medium&quot; } |&gt; Moar.Map . rename_key ( &quot;color&quot; , &quot;colour&quot; ) %{ &quot;colour&quot; =&gt; &quot;red&quot; , &quot;size&quot; =&gt; &quot;medium&quot; }","ref":"Moar.Map.html#rename_key/3","title":"Moar.Map.rename_key/3","type":"function"},{"doc":"Returns a copy of map after changing key names supplied by keys_map . %{ &quot;behavior&quot; =&gt; &quot;chill&quot; , &quot;color&quot; =&gt; &quot;red&quot; } |&gt; Moar.Map . rename_keys ( %{ &quot;behavior&quot; =&gt; &quot;behaviour&quot; , &quot;color&quot; =&gt; &quot;colour&quot; } ) %{ &quot;behaviour&quot; =&gt; &quot;chill&quot; , &quot;colour&quot; =&gt; &quot;red&quot; }","ref":"Moar.Map.html#rename_keys/2","title":"Moar.Map.rename_keys/2","type":"function"},{"doc":"Converts keys in map to strings. iex&gt; Moar.Map . stringify_keys ( %{ a : 1 , b : 2 } ) %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; 2 }","ref":"Moar.Map.html#stringify_keys/1","title":"Moar.Map.stringify_keys/1","type":"function"},{"doc":"Transforms values of map using transformer function. iex&gt; %{ &quot;foo&quot; =&gt; &quot;chicken&quot; , &quot;bar&quot; =&gt; &quot;cow&quot; , &quot;baz&quot; =&gt; &quot;pig&quot; } |&gt; Moar.Map . transform ( &quot;foo&quot; , &amp; String . upcase / 1 ) %{ &quot;foo&quot; =&gt; &quot;CHICKEN&quot; , &quot;bar&quot; =&gt; &quot;cow&quot; , &quot;baz&quot; =&gt; &quot;pig&quot; } iex&gt; %{ &quot;foo&quot; =&gt; &quot;chicken&quot; , &quot;bar&quot; =&gt; &quot;cow&quot; , &quot;baz&quot; =&gt; &quot;pig&quot; } |&gt; Moar.Map . transform ( [ &quot;foo&quot; , &quot;bar&quot; ] , &amp; String . upcase / 1 ) %{ &quot;foo&quot; =&gt; &quot;CHICKEN&quot; , &quot;bar&quot; =&gt; &quot;COW&quot; , &quot;baz&quot; =&gt; &quot;pig&quot; }","ref":"Moar.Map.html#transform/3","title":"Moar.Map.transform/3","type":"function"},{"doc":"Protocol-related functions.","ref":"Moar.Protocol.html","title":"Moar.Protocol","type":"module"},{"doc":"Returns x or raises if x does not implment protocol . iex&gt; Moar.Protocol . implements! ( ~D[2000-01-02] , String.Chars ) ~D[2000-01-02]","ref":"Moar.Protocol.html#implements!/2","title":"Moar.Protocol.implements!/2","type":"function"},{"doc":"Generate random data.","ref":"Moar.Random.html","title":"Moar.Random","type":"module"},{"doc":"Returns a random integer between 0 and max .","ref":"Moar.Random.html#integer/1","title":"Moar.Random.integer/1","type":"function"},{"doc":"Returns a base64- or base32-encoded random string of 32 characters. See Moar.Random.string/2 .","ref":"Moar.Random.html#string/1","title":"Moar.Random.string/1","type":"function"},{"doc":"Returns a base64- or base32-encoded random string of given length. iex&gt; Moar.Random . string ( ) &quot;Sr/y4m/YiVSJcIgI5lG+76vMfaZ7KZ7c&quot; iex&gt; Moar.Random . string ( 5 ) &quot;9pJrK&quot; iex&gt; Moar.Random . string ( 5 , :base32 ) &quot;AC53Z&quot;","ref":"Moar.Random.html#string/2","title":"Moar.Random.string/2","type":"function"},{"doc":"","ref":"Moar.Random.html#t:encoding/0","title":"Moar.Random.encoding/0","type":"type"},{"doc":"","ref":"Moar.Retry.html","title":"Moar.Retry","type":"module"},{"doc":"","ref":"Moar.Retry.html#rescue_for!/2","title":"Moar.Retry.rescue_for!/2","type":"function"},{"doc":"","ref":"Moar.Retry.html#rescue_until!/2","title":"Moar.Retry.rescue_until!/2","type":"function"},{"doc":"String-related functions.","ref":"Moar.String.html","title":"Moar.String","type":"module"},{"doc":"Convert strings and atoms to dash-case (kebab-case) and trims leading and trailing non-alphanumeric characters. iex&gt; [ &quot;foo&quot; , &quot;FOO&quot; , :foo ] |&gt; Enum . map ( &amp; Moar.String . dasherize / 1 ) [ &quot;foo&quot; , &quot;foo&quot; , &quot;foo&quot; ] iex&gt; [ &quot;foo-bar&quot; , &quot;foo_bar&quot; , :foo_bar , &quot; fooBar &quot; , &quot; ?foo ! bar &quot; ] |&gt; Enum . map ( &amp; Moar.String . dasherize / 1 ) [ &quot;foo-bar&quot; , &quot;foo-bar&quot; , &quot;foo-bar&quot; , &quot;foo-bar&quot; , &quot;foo-bar&quot; ]","ref":"Moar.String.html#dasherize/1","title":"Moar.String.dasherize/1","type":"function"},{"doc":"Truncate s to max_length by replacing the middle of the string with replacement , which defaults to the single unicode character … . Note that the final length of the string will be max_length plus the length of replacement . iex&gt; Moar.String . inner_truncate ( &quot;abcdefghijklmnopqrstuvwxyz&quot; , 10 ) &quot;abcde…vwxyz&quot; iex&gt; Moar.String . inner_truncate ( &quot;abcdefghijklmnopqrstuvwxyz&quot; , 10 , &quot;&lt;==&gt;&quot; ) &quot;abcde&lt;==&gt;vwxyz&quot;","ref":"Moar.String.html#inner_truncate/3","title":"Moar.String.inner_truncate/3","type":"function"},{"doc":"Compares the two binaries in constant-time to avoid timing attacks. See: http://codahale.com/a-lesson-in-timing-attacks/ . iex&gt; Moar.String . secure_compare ( &quot;foo&quot; , &quot;bar&quot; ) false","ref":"Moar.String.html#secure_compare/2","title":"Moar.String.secure_compare/2","type":"function"},{"doc":"Trims a string and replaces consecutive whitespace characters with a single space. iex&gt; Moar.String . squish ( &quot; foo bar baz &quot; ) &quot;foo bar baz&quot;","ref":"Moar.String.html#squish/1","title":"Moar.String.squish/1","type":"function"},{"doc":"Adds surrounder to the beginning and end of s . iex&gt; Moar.String . surround ( &quot;Hello&quot; , &quot;**&quot; ) &quot;**Hello**&quot;","ref":"Moar.String.html#surround/2","title":"Moar.String.surround/2","type":"function"},{"doc":"Adds prefix to the beginning of s and suffix to the end. iex&gt; Moar.String . surround ( &quot;Hello&quot; , &quot;“&quot; , &quot;”&quot; ) &quot;“Hello”&quot;","ref":"Moar.String.html#surround/3","title":"Moar.String.surround/3","type":"function"},{"doc":"Converts a string to an integer. Returns nil if the argument is nil or empty string. iex&gt; Moar.String . to_integer ( &quot;12,345&quot; ) 12_345","ref":"Moar.String.html#to_integer/1","title":"Moar.String.to_integer/1","type":"function"},{"doc":"Like to_integer/1 but with options: :lenient option removes non-digit characters first default: option specifies a default in case s is nil iex&gt; Moar.String . to_integer ( &quot;USD$25&quot; , :lenient ) 25 iex&gt; Moar.String . to_integer ( nil , default : 0 ) 0","ref":"Moar.String.html#to_integer/2","title":"Moar.String.to_integer/2","type":"function"},{"doc":"Like String.trim/1 but returns nil if the argument is nil.","ref":"Moar.String.html#trim/1","title":"Moar.String.trim/1","type":"function"},{"doc":"Truncates s at the last instance of at , causing the string to be at most limit characters. iex&gt; Moar.String . truncate_at ( &quot;I like apples. I like bananas. I like cherries.&quot; , &quot;.&quot; , 35 ) &quot;I like apples. I like bananas.&quot;","ref":"Moar.String.html#truncate_at/3","title":"Moar.String.truncate_at/3","type":"function"},{"doc":"Syntactic sugar functions. These functions are intended to be used by importing the functions or the whole module: import Moar.Sugar , only : [ noreply : 1 ] def handle_event ( &quot;foo&quot; , _params , socket ) do socket |&gt; assign ( foo : &quot;bar&quot; ) |&gt; noreply ( ) end","ref":"Moar.Sugar.html","title":"Moar.Sugar","type":"module"},{"doc":"Unwraps an :error tuple, raising if the term is not an :error tuple. iex&gt; { :error , 1 } |&gt; Moar.Sugar . error! ( ) 1","ref":"Moar.Sugar.html#error!/1","title":"Moar.Sugar.error!/1","type":"function"},{"doc":"Wraps a term in an :error tuple. Useful in pipelines. iex&gt; %{ } |&gt; Map . put ( :count , &quot;unknown&quot; ) |&gt; Moar.Sugar . error ( ) { :error , %{ count : &quot;unknown&quot; } }","ref":"Moar.Sugar.html#error/1","title":"Moar.Sugar.error/1","type":"function"},{"doc":"Wraps a term in a :noreply tuple. iex&gt; %{ } |&gt; Map . put ( :count , 0 ) |&gt; Moar.Sugar . noreply ( ) { :noreply , %{ count : 0 } }","ref":"Moar.Sugar.html#noreply/1","title":"Moar.Sugar.noreply/1","type":"function"},{"doc":"Unwraps an :ok tuple, raising if the term is not an :ok tuple. iex&gt; { :ok , 1 } |&gt; Moar.Sugar . ok! ( ) 1","ref":"Moar.Sugar.html#ok!/1","title":"Moar.Sugar.ok!/1","type":"function"},{"doc":"Wraps a term in an :ok tuple. iex&gt; %{ } |&gt; Map . put ( :count , 10 ) |&gt; Moar.Sugar . ok ( ) { :ok , %{ count : 10 } }","ref":"Moar.Sugar.html#ok/1","title":"Moar.Sugar.ok/1","type":"function"},{"doc":"Accepts two arguments and returns the second. Useful at the end of the pipeline when you want to return a different value than the last result of the pipeline, such as when the pipeline has side effects. iex&gt; %{ } |&gt; Map . put ( :count , 20 ) |&gt; Moar.Sugar . returning ( :count_updated ) :count_updated","ref":"Moar.Sugar.html#returning/2","title":"Moar.Sugar.returning/2","type":"function"},{"doc":"Blank/present functions for terms. A term is considered present when it is not blank. A term is considered blank when: it is nil it is false it is a string, and its length after being trimmed is 0 it is an empty list it is an empty map","ref":"Moar.Term.html","title":"Moar.Term","type":"module"},{"doc":"Returns true if the term is blank, nil, or empty. iex&gt; Moar.Term . blank? ( nil ) true iex&gt; Moar.Term . blank? ( &quot; &quot; ) true iex&gt; Moar.Term . blank? ( [ ] ) true iex&gt; Moar.Term . blank? ( %{ } ) true","ref":"Moar.Term.html#blank?/1","title":"Moar.Term.blank?/1","type":"function"},{"doc":"Returns the value if it is present (via present? ), or else returns the default value. iex&gt; Moar.Term . presence ( 20 , 100 ) 20 iex&gt; Moar.Term . presence ( nil , 100 ) 100","ref":"Moar.Term.html#presence/2","title":"Moar.Term.presence/2","type":"function"},{"doc":"Returns true if the term is not blank, nil, or empty. iex&gt; Moar.Term . present? ( 1 ) true iex&gt; Moar.Term . present? ( [ 1 ] ) true iex&gt; Moar.Term . present? ( %{ a : 1 } ) true iex&gt; Moar.Term . present? ( &quot;1&quot; ) true","ref":"Moar.Term.html#present?/1","title":"Moar.Term.present?/1","type":"function"},{"doc":"","ref":"Moar.Tuple.html","title":"Moar.Tuple","type":"module"},{"doc":"Converts a list of tuples to a single tuple where the first element is the first element of the first tuple, and the second element is a list of the second elements of each tuple. Raises if the first element in each tuple is not homogeneous. iex&gt; Moar.Tuple . from_list! ( [ { :ok , :a } , { :ok , :b } ] ) { :ok , [ :a , :b ] } iex&gt; Moar.Tuple . from_list! ( [ { :a , 1 } , { :a , 2 } , { :a , 3 } ] ) { :a , [ 1 , 2 , 3 ] } iex&gt; Moar.Tuple . from_list! ( [ { :a , 1 } , { :b , 2 } , { :a , 3 } ] ) ** (RuntimeError) Expected all items in the list to have have the same first element, but got: [:a, :b]","ref":"Moar.Tuple.html#from_list!/1","title":"Moar.Tuple.from_list!/1","type":"function"},{"doc":"An assortment of useful functions. The docs can be found at https://hexdocs.pm/moar","ref":"readme.html","title":"Moar","type":"extras"},{"doc":"The package can be installed by adding moar to your list of dependencies in mix.exs : def deps do [ { :moar , &quot;~&gt; 1.2&quot; } ] end","ref":"readme.html#installation","title":"Moar - Installation","type":"extras"},{"doc":"Copyright 2022 synchronal.dev Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]